#!/usr/bin/env python2
#
#  Copyright (C) 2002  Travis Shirk <travis@pobox.com>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
import re;
from eyeD3.binfuncs import *;

class OggTag:

   def parse(self, fileName):
      oggFile = file(fileName, "rb");
      buffer = "";
      chunkSize = 1024;

      # If the data contains three instances of "vorbis" then we
      # know that we have all of header 1 (The Identification Header),
      # all of header 2 (The Comment Header), and at least part of 
      # header 3 (The Setup Header).  The second one is the only one we're
      # interested in.
      while len(re.findall("vorbis", buffer)) < 3:
         data = oggFile.read(chunkSize);
         if data:
            buffer += data;
         else:
            oggFile.close();
            raise "Entire file read and no Vorbis comment header was found";
      oggFile.close();

      # TODO: Need error checking here.
      commentBegMarker = "\x03vorbis";
      commentEndMarker = "\x05vorbis";
      commentBegPos = re.search(commentBegMarker, buffer);
      commentEndPos = re.search(commentEndMarker, buffer);

      tagData = buffer[commentBegPos.start():commentEndPos.start()];
      readPos = len(commentBegMarker);

      byteStr = list(tagData[readPos:readPos + 4]);
      byteStr.reverse();
      vendorLen = bin2dec(bytes2bin(byteStr));
      readPos += 4;

      vendorStr = tagData[readPos:readPos + vendorLen];
      print vendorStr;
      print len(vendorStr);
      readPos += vendorLen;

      byteStr = list(tagData[readPos:readPos + 4]);
      byteStr.reverse();
      numComments = bin2dec(bytes2bin(byteStr));
      readPos += 4;
      print numComments;

      count = 1;
      while count <= numComments:
         # Read length of user comment
         byteStr = list(tagData[readPos:readPos + 4]);
         byteStr.reverse();
         commentLen = bin2dec(bytes2bin(byteStr));
         readPos += 4;

         # Read user comment.
         comment = tagData[readPos:readPos + commentLen];
         readPos += commentLen;
         # Parse field name and value, each separated by a '='
         # TODO
         print comment;

         count += 1;

      # Read framing bit and error (why??) if it's not set or not there.
      byteStr = list(tagData[readPos]);   
      framingByte = bin2dec(bytes2bin(byteStr));
      if not framingByte & 1:
         raise "Framing bit not set";



f = "/home/travis/devel/eyeD3/samples/sample.ogg";
tag = OggTag();
tag.parse(f);
